1#!/bin/sh
2
3case "$1" in
4 --help)
5 echo "usage: $0 [--config file] [other_git_tree...] [--] [test_scripts]"
6 exit 0
7 ;;
8 --config)
9 shift
10 GIT_PERF_CONFIG_FILE=$(cd "$(dirname "$1")"; pwd)/$(basename "$1")
11 export GIT_PERF_CONFIG_FILE
12 shift ;;
13esac
14
15die () {
16 echo >&2 "error: $*"
17 exit 1
18}
19
20run_one_dir () {
21 if test $# -eq 0; then
22 set -- p????-*.sh
23 fi
24 echo "=== Running $# tests in ${GIT_TEST_INSTALLED:-this tree} ==="
25 for t in "$@"; do
26 ./$t $GIT_TEST_OPTS
27 done
28}
29
30unpack_git_rev () {
31 rev=$1
32 echo "=== Unpacking $rev in build/$rev ==="
33 mkdir -p build/$rev
34 (cd "$(git rev-parse --show-cdup)" && git archive --format=tar $rev) |
35 (cd build/$rev && tar x)
36}
37
38build_git_rev () {
39 rev=$1
40 name="$2"
41 for config in config.mak config.mak.autogen config.status
42 do
43 if test -e "../../$config"
44 then
45 cp "../../$config" "build/$rev/"
46 fi
47 done
48 echo "=== Building $rev ($name) ==="
49 (
50 cd build/$rev &&
51 if test -n "$GIT_PERF_MAKE_COMMAND"
52 then
53 sh -c "$GIT_PERF_MAKE_COMMAND"
54 else
55 make $GIT_PERF_MAKE_OPTS
56 fi
57 ) || die "failed to build revision '$mydir'"
58}
59
60run_dirs_helper () {
61 mydir=${1%/}
62 shift
63 while test $# -gt 0 -a "$1" != -- -a ! -f "$1"; do
64 shift
65 done
66 if test $# -gt 0 -a "$1" = --; then
67 shift
68 fi
69 if [ ! -d "$mydir" ]; then
70 rev=$(git rev-parse --verify "$mydir" 2>/dev/null) ||
71 die "'$mydir' is neither a directory nor a valid revision"
72 if [ ! -d build/$rev ]; then
73 unpack_git_rev $rev
74 fi
75 build_git_rev $rev "$mydir"
76 mydir=build/$rev
77 fi
78 if test "$mydir" = .; then
79 unset GIT_TEST_INSTALLED
80 else
81 GIT_TEST_INSTALLED="$mydir/bin-wrappers"
82 # Older versions of git lacked bin-wrappers; fallback to the
83 # files in the root.
84 test -d "$GIT_TEST_INSTALLED" || GIT_TEST_INSTALLED=$mydir
85 export GIT_TEST_INSTALLED
86 fi
87 run_one_dir "$@"
88}
89
90run_dirs () {
91 while test $# -gt 0 -a "$1" != -- -a ! -f "$1"; do
92 run_dirs_helper "$@"
93 shift
94 done
95}
96
97get_subsections () {
98 section="$1"
99 test -z "$GIT_PERF_CONFIG_FILE" && return
100 git config -f "$GIT_PERF_CONFIG_FILE" --name-only --get-regex "$section\..*\.[^.]+" |
101 sed -e "s/$section\.\(.*\)\..*/\1/" | sort | uniq
102}
103
104get_var_from_env_or_config () {
105 env_var="$1"
106 conf_sec="$2"
107 conf_var="$3"
108 # $4 can be set to a default value
109
110 # Do nothing if the env variable is already set
111 eval "test -z \"\${$env_var+x}\"" || return
112
113 test -z "$GIT_PERF_CONFIG_FILE" && return
114
115 # Check if the variable is in the config file
116 if test -n "$GIT_PERF_SUBSECTION"
117 then
118 var="$conf_sec.$GIT_PERF_SUBSECTION.$conf_var"
119 conf_value=$(git config -f "$GIT_PERF_CONFIG_FILE" "$var") &&
120 eval "$env_var=\"$conf_value\"" && return
121 fi
122 var="$conf_sec.$conf_var"
123 conf_value=$(git config -f "$GIT_PERF_CONFIG_FILE" "$var") &&
124 eval "$env_var=\"$conf_value\"" && return
125
126 test -n "${4+x}" && eval "$env_var=\"$4\""
127}
128
129run_subsection () {
130 get_var_from_env_or_config "GIT_PERF_REPEAT_COUNT" "perf" "repeatCount" 3
131 export GIT_PERF_REPEAT_COUNT
132
133 get_var_from_env_or_config "GIT_PERF_DIRS_OR_REVS" "perf" "dirsOrRevs"
134 set -- $GIT_PERF_DIRS_OR_REVS "$@"
135
136 get_var_from_env_or_config "GIT_PERF_MAKE_COMMAND" "perf" "makeCommand"
137 get_var_from_env_or_config "GIT_PERF_MAKE_OPTS" "perf" "makeOpts"
138
139 GIT_PERF_AGGREGATING_LATER=t
140 export GIT_PERF_AGGREGATING_LATER
141
142 if test $# = 0 -o "$1" = -- -o -f "$1"; then
143 set -- . "$@"
144 fi
145
146 run_dirs "$@"
147 ./aggregate.perl "$@"
148}
149
150cd "$(dirname $0)"
151. ../../GIT-BUILD-OPTIONS
152
153mkdir -p test-results
154get_subsections "perf" >test-results/run_subsections.names
155
156if test $(wc -l <test-results/run_subsections.names) -eq 0
157then
158 (
159 run_subsection "$@"
160 )
161else
162 while read -r subsec
163 do
164 (
165 GIT_PERF_SUBSECTION="$subsec"
166 export GIT_PERF_SUBSECTION
167 echo "======== Run for subsection '$GIT_PERF_SUBSECTION' ========"
168 run_subsection "$@"
169 )
170 done <test-results/run_subsections.names
171fi